



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java设计模式之--代理模式学习</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java设计模式之--代理模式学习</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-09 17:26:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>1.代理模式定义</strong></p>
<p>　　为其他对象提供一种代理以控制对这个对象的访问。代理对象起到中介服务，可以去掉功能服务和增加额外的服务。</p>
<p>　　其实按照官方的说法可能不太好理解，代理模式就好比我们生活中买票，一般情况下我们都会去火车站（原对象）买票，但是有的情况下可能我们离火车站比较远不方便去，那我们就会去火车票代售点去（我们的代理对象）买，在这里代售处就是对火车站的一个代理，可以实现卖票的功能，同时呢，代售处也有自己的额外的功能，比如火车票代售处买票需要额外的手续费，火车站能提供的所有服务代售处不是全有，比如代售处不能退票、不能购买学生票，从这里可以看出代理实现了原对象的部分功能外，也有自己额外的处理。</p>
<p><strong>2.代理模式实现--静态代理</strong></p>
<p><strong>　　</strong>静态代理：代理和被代理的对象在代理之前都是确定的，他们都是实现了相同的接口或者继承了相同的抽象类。</p>
<p>　　举例说明下：汽车有一个move()方法，然后我想通过代理来实现记录汽车运行过程中时间的问题。</p>
<p>　　Moveable.java &nbsp;//定义一个统一的接口,里面定义了一个汽车行驶move()方法</p>
<div>
<pre class="prettyprint linenums"> public interface Moveable {<br />
     void move();

 }</pre>
</div>
<p>　　Car.java(版本一) &nbsp; //实现了Moveable接口，实现move方法</p>
<div>
<pre class="prettyprint linenums">public class Car implements Moveable {

    public void move() {<br />
        try {<br />
            Thread.sleep(new Random().nextInt(1000));<br />
            System.out.println("汽车行驶中....");<br />
        } catch (InterruptedException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }

}</pre>
</div>
<p>　　在这里要实现增加记录汽车运行时间问题，我们是不是可以直接修改Car.java的move方法，如下所示：</p>
<div>
<pre class="prettyprint linenums">public class Car implements Moveable {

    public void move() {<br />
        System.out.println("汽车行驶开始");<br />
        long begin = System.currentTimeMillis();<br />
        try {<br />
            Thread.sleep(new Random().nextInt(1000));<br />
            System.out.println("汽车行驶中....");<br />
        } catch (InterruptedException e) {<br />
            e.printStackTrace();<br />
        }<br />
        long end = System.currentTimeMillis();<br />
        System.out.println("汽车行驶了"+(end-begin)+"毫秒");<br />
    }

}</pre>
</div>
<p>　　这样就实现了记录行驶时间，但是这个得修改Car.java源码，在不修改源码的情况下，怎么做呢，我们就可以通过代理来实现,这里我们将Car.java还原为版本一时候</p>
<p>　　Car2.java //新增Car2，继承了Car</p>
<div>
<pre class="prettyprint linenums"> public class Car2 extends Car {

     public void move() {<br />
         System.out.println("汽车行驶开始");<br />
         long begin = System.currentTimeMillis();<br />
         <strong>super.move();<br />
</strong>         long end = System.currentTimeMillis();<br />
         System.out.println("汽车行驶了"+(end-begin)+"毫秒");<br />
     }

 }</pre>
</div>
<p>　　Client.java &nbsp; //测试类，</p>
<div>
<pre class="prettyprint linenums"> public class Client {<br />
     public static void main(String[] args) {<br />
 //        Car car = new Car();<br />
 //        car.move();<br />
         Moveable m = new Car2();<br />
         m.move();<br />
     }

 }</pre>
</div>
<p>　　可以看到运行结果：</p>
<div>
<pre class="prettyprint linenums">汽车行驶开始<br />
汽车行驶中....<br />
汽车行驶了314毫秒</pre>
</div>
<p>　　这样就通过代理实现了记录时间的问题。在super.move();之前和之后我们可以添加新的服务。</p>
<p>　　上面我们是通过的继承的方式来实现代理，下面我们换一种方式，用聚合的方式来实现代理模式。</p>
<p>　　Car3.java &nbsp;//新增Car3.java ，采用聚合方式实现</p>
<div>
<pre class="prettyprint linenums"> public class Car3 implements Moveable {<br />
     private Car car;

     public Car3(Car car){<br />
         this.car = car;<br />
     }

     public void move() {<br />
         System.out.println("汽车行驶开始");<br />
         long begin = System.currentTimeMillis();<br />
         car.move();<br />
         long end = System.currentTimeMillis();<br />
         System.out.println("汽车行驶了"+(end-begin)+"毫秒");<br />
     }

 }</pre>
</div>
<p>　　修改Client.java来测试，</p>
<div>
<pre class="prettyprint linenums"> public class Client {<br />
     public static void main(String[] args) {<br />
         //采用聚合方式测试代码<br />
         Car car = new Car();<br />
         Car3 car3 = new Car3(car);<br />
         car3.move();<br />
     }

 }</pre>
</div>
<p>　　通过运行我们可以得到相同的结果，都可以实现相同的功能。</p>
<p>　　但是哪一种方式更好呢，这里我们仅仅是需要增加个记录时间的功能，假如我们需要增加功能有1.时间记录2.日志记录3.权限控制等，可能有的汽车需要先记录时间在记录日志在是权限，即是123方式，可能有的汽车需要321方式，有的汽车只需要1等等，如果我们采用继承的方式的话，每一种方式我们会创建一个新的Java类，这样的话我们的类会无限的庞大，所以推荐使用聚合方式来实现，那聚合方式怎么实现呢，且看下文。</p>
<p>　　CarTimeProxy.java &nbsp;//时间代理类，完成对记录时间的代理功能</p>
<div>
<pre class="prettyprint linenums"> public class CarTimeProxy implements Moveable {<br />
     private Moveable m;

     public CarTimeProxy(Moveable m){<br />
         this.m = m;<br />
     }

     public void move() {<br />
         System.out.println("汽车行驶开始");<br />
         long begin = System.currentTimeMillis();<br />
         m.move();<br />
         long end = System.currentTimeMillis();<br />
         System.out.println("汽车行驶了"+(end-begin)+"毫秒");<br />
     }

 }</pre>
</div>
<p>　　CarLogProxy.java &nbsp;//日志代理类，完成对日志的记录</p>
<div>
<pre class="prettyprint linenums"> public class CarLogProxy implements Moveable {<br />
     private Moveable m;

     public CarLogProxy(Moveable m){<br />
         this.m = m;<br />
     }

     public void move() {<br />
         System.out.println("汽车日志记录开始");<br />
         m.move();<br />
         System.out.println("汽车日志记录结束");<br />
     }

 }</pre>
</div>
<p>　　修改Client.java来测试，假如我们先记录日志在记录时间</p>
<div>
<pre class="prettyprint linenums"> public class Client {<br />
     public static void main(String[] args) {<br />
         Car car = new Car();<br />
         CarTimeProxy time = new CarTimeProxy(car);<br />
         CarLogProxy log = new CarLogProxy(time);<br />
         log.move();<br />
     }

 }</pre>
</div>
<p>　　结果可以看出，先是记录了日志在是时间</p>
<div>
<pre class="prettyprint linenums">汽车日志记录开始<br />
汽车行驶开始<br />
汽车行驶中....<br />
汽车行驶了586毫秒<br />
汽车日志记录结束</pre>
</div>
<p>　　这里假如我们需要先记录时间在记录日志，我们仅仅是代码顺序切换下就OK了，</p>
<div>
<pre class="prettyprint linenums"> public class Client {<br />
     public static void main(String[] args) {<br />
         Car car = new Car();<br />
         CarLogProxy log = new CarLogProxy(car);<br />
         CarTimeProxy time = new CarTimeProxy(log);<br />
         time.move();<br />
     }

 }</pre>
</div>
<div>
<pre class="prettyprint linenums">汽车行驶开始<br />
汽车日志记录开始<br />
汽车行驶中....<br />
汽车日志记录结束<br />
汽车行驶了192毫秒</pre>
</div>
<p>　　从这里可以看出，聚合的方式比继承更适合代理模式</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qydyggq.html">使用gulp解决RequireJS项目前端缓存问题（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy5e329.html">linux配置ftp</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxndevd8.html">ORA-04031案例一则</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd64zr8.html">Android 内存分析工具 MAT&lpar;Memory Analyzer Tool&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y5jn5q.html">PAT 1016&period; Phone Bills</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvwprjq.html">css（display，float，position）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdenllx9.html">Java中的内存泄漏问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yx210q.html">SpringMVC、SpringMVC  XML配置（纯XML方式）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjjxxl8.html">日积月累：weightSum和layout&lowbar;weight属性合用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2vg4x9.html">RAS算法简单示例（Java版）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rvv758.html">Android为TV端助力 android 在5&period;0以后不允许使用隐式Intent方式来启动Service</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvy5xg8.html">pngcrush caught libpng error原因及解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5725dq.html">hiho一下 第168周</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r4ex68.html">Jquery实现轮播效果图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlld23xq.html">python eric6 IDE</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5poeeq.html">headfirst python 05&comma; 06</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rx3j49.html">你不知道的JavaScript（1）LHS查询和RHS查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o17001q.html">SQL Server 2008 表分区的含义</a>
		</li>
						<li><a href="https://www.batexi.com/a/902mpxnq.html">spring 5&period;0&period;1&period;RELEASE官方任然不支持velocity&lpar;平台升级&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9630gjj9.html">【colaboratory】ModuleNotFoundError&colon; No module named &amp;&num;39&semi;forward&amp;&num;39&semi;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7mnzkeq.html">JS分割字符串并放入数组的函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjxwry9.html">laravel 5&period;0 artisan 命令列表（中文简体）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zjvk09.html">配置Sublime Text 3的Python开发环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmd3pz9.html">easyui datagrid 列拖拽</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm5ovk9.html">Spring3 Security 中配置会话管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm5o309.html">web 项目  布在tomcat服务器上出现的问题小记</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xndxn9.html">PN-Traniger</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xnd6z9.html">基于 SOA 的组件化业务基础平台</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o550n9.html">Dapper ORM 用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnee7e8.html">UIImage的简单用法和实际操作</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
